/*
 * This file is generated by jOOQ.
*/
package cc.cinnamon.canary.users.model.tables


import cc.cinnamon.canary.users.model.Keys
import cc.cinnamon.canary.users.model.Public
import org.jooq.*
import org.jooq.impl.TableImpl

import javax.annotation.Generated
import java.util.Arrays


/**
 * This class is generated by jOOQ.
 */
@Generated(value = *arrayOf("http://www.jooq.org", "jOOQ version:3.9.1", "schema version:public_4"), date = "2017-02-20T21:56:50.783Z", comments = "This class is generated by jOOQ")
class Roles private constructor(alias: String, aliased: Table<Record>, parameters: Array<Field<*>>? = null) : TableImpl<Record>(alias, null, aliased, parameters, "") {

    /**
     * The class holding records for this type
     */
    override fun getRecordType(): Class<Record> {
        return Record::class.java
    }

    /**
     * The column `public.roles.id`.
     */
    val ID = AbstractTable.createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaultValue(org.jooq.impl.DSL.field("nextval('roles_id_seq'::regclass)", org.jooq.impl.SQLDataType.BIGINT)), this, "")

    /**
     * The column `public.roles.name`.
     */
    val NAME = AbstractTable.createField("name", org.jooq.impl.SQLDataType.VARCHAR.length(10).nullable(false), this, "")

    /**
     * The column `public.roles.description`.
     */
    val DESCRIPTION = AbstractTable.createField("description", org.jooq.impl.SQLDataType.CLOB, this, "")

    /**
     * Create a `public.roles` table reference
     */
    constructor() : this("roles", null) {
    }

    /**
     * Create an aliased `public.roles` table reference
     */
    constructor(alias: String) : this(alias, ROLES) {
    }

    /**
     * {@inheritDoc}
     */
    override fun getSchema(): Schema {
        return Public.PUBLIC
    }

    /**
     * {@inheritDoc}
     */
    override fun getIdentity(): Identity<Record, Long> {
        return Keys.IDENTITY_ROLES
    }

    /**
     * {@inheritDoc}
     */
    override fun getPrimaryKey(): UniqueKey<Record> {
        return Keys.ROLES_PKEY
    }

    /**
     * {@inheritDoc}
     */
    override fun getKeys(): List<UniqueKey<Record>> {
        return Arrays.asList(Keys.ROLES_PKEY)
    }

    /**
     * {@inheritDoc}
     */
    override fun `as`(alias: String): Roles {
        return Roles(alias, this)
    }

    /**
     * Rename this table
     */
    override fun rename(name: String): Roles {
        return Roles(name, null)
    }

    companion object {

        private val serialVersionUID: Long = 428700352

        /**
         * The reference instance of `public.roles`
         */
        val ROLES = Roles()
    }
}
